from typing import Any, Optional, Tuple, Type

from django.http.request import HttpRequest

from django.db import models

SITE_CACHE: Any

class SiteManager(models.Manager):
    def get_current(self, request: Optional[HttpRequest] = ...) -> Site: ...
    def clear_cache(self) -> None: ...
    def get_by_natural_key(self, domain: str) -> Site: ...

class Site(models.Model):
    domain: models.CharField = ...
    name: models.CharField = ...
    objects: SiteManager = ...
    def natural_key(self) -> Tuple[str]: ...

def clear_site_cache(sender: Type[Site], **kwargs: Any) -> None: ...
